# coct-sr-api-client
API for interacting with City of Cape Town's eServices

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.2
- Package version: 0.3.0
- Generator version: 7.6.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import coct_sr_api_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import coct_sr_api_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import coct_sr_api_client
from coct_sr_api_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://qaeservices1.capetown.gov.za/coct/api
# See configuration.py for a list of all supported configuration parameters.
configuration = coct_sr_api_client.Configuration(
    host = "https://qaeservices1.capetown.gov.za/coct/api"
)



# Enter a context with an instance of the API client
with coct_sr_api_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = coct_sr_api_client.AuthGroupApi(api_client)
    cookie = 'cookie_example' # str | 

    try:
        api_instance.zcur_guest_login_get(cookie)
    except ApiException as e:
        print("Exception when calling AuthGroupApi->zcur_guest_login_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://qaeservices1.capetown.gov.za/coct/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AuthGroupApi* | [**zcur_guest_login_get**](docs/AuthGroupApi.md#zcur_guest_login_get) | **GET** /zcur-guest/login | 
*AuthGroupApi* | [**zsreq_session_get**](docs/AuthGroupApi.md#zsreq_session_get) | **GET** /zsreq/session | Returns a new session identifier, to be used in subsequent requests as the value for the X-Session header.
*ConfigGroupApi* | [**zsreq_config_subtypes_get**](docs/ConfigGroupApi.md#zsreq_config_subtypes_get) | **GET** /zsreq/config/subtypes | Returns the full set of request types or codes, and their descriptions for the City&#39;s Service Requests.
*ConfigGroupApi* | [**zsreq_config_types_get**](docs/ConfigGroupApi.md#zsreq_config_types_get) | **GET** /zsreq/config/types | Returns the full set of request types or codes, and their descriptions for the City&#39;s Service Requests.
*ServiceRequestGroupApi* | [**zsreq_sr_post**](docs/ServiceRequestGroupApi.md#zsreq_sr_post) | **POST** /zsreq/sr | This operation is used to create a service request in the City’s system.
*ServiceRequestGroupApi* | [**zsreq_sr_reference_no_get**](docs/ServiceRequestGroupApi.md#zsreq_sr_reference_no_get) | **GET** /zsreq/sr/{reference_no} | This operation is used to retrieve the current state of a service request given the service request number.


## Documentation For Models

 - [ConfigSubtypeSchema](docs/ConfigSubtypeSchema.md)
 - [ConfigTypeSchema](docs/ConfigTypeSchema.md)
 - [ErrorSchema](docs/ErrorSchema.md)
 - [LoginSchema](docs/LoginSchema.md)
 - [RequestAttributeResponseSchema](docs/RequestAttributeResponseSchema.md)
 - [RequestAttributesLookupSchema](docs/RequestAttributesLookupSchema.md)
 - [RequestAttributesSchema](docs/RequestAttributesSchema.md)
 - [SessionSchema](docs/SessionSchema.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="signatureAuth"></a>
### signatureAuth

- **Type**: API key
- **API key parameter name**: X-Signature
- **Location**: HTTP header

<a id="cookieAuth"></a>
### cookieAuth

- **Type**: API key
- **API key parameter name**: MYSAPSSO2
- **Location**: 

<a id="serviceAuth"></a>
### serviceAuth

- **Type**: API key
- **API key parameter name**: X-Service
- **Location**: HTTP header

<a id="sessionAuth"></a>
### sessionAuth

- **Type**: API key
- **API key parameter name**: X-Session
- **Location**: HTTP header


## Author




